- Imports and Setup
  - [Browser Compatibility](home#browser)
  - [Setup](home#setup)
  - [Doctype](home#doctype)
  - [Required Imports](home#imports)
  - [Initializing jsPlumb](home#initializing)
  - [Multiple jsPlumb Instances](home#multiple)
  - [Z-Index Considerations](home#zindex)
  - [Where does jsPlumb add elements?](home#container)
  - [Performance](home#performance)
  - [Zooming](zooming)
  - [Configuring Defaults](defaults)
- Concepts
  - [Introduction](basic-concepts)
  - [Anchors](anchors)
  - [Connectors](connectors)
  - [Endpoints](endpoints)
  - [Overlays](overlays)
  - [Groups](groups)
  - [Scrollable Lists](lists)
- Nodes
  - [Element Dragging](dragging)
- Connections
  - [Overview](connections)
  - [Programmatic Connections](connections#programmatic)
  - [Reusing Common Settings](connections#common)
  - [Detaching Programmatic Connections](connections#detaching)
  - [Drag and Drop Connections](connections#draganddrop)
  - [Elements as sources &amp; targets](connections#sourcesandtargets)
  - [Element Targets](connections#maketarget)
  - [Element Sources](connections#makesource)
  - [Specifying drag source area](connections#sourcefilter)
  - [Removing Connections/Endpoints](removing)
  - [Connection & Endpoint Parameters](parameters)
- Connection & Endpoint Types
  - [Introduction](types)
  - [Connection Types](types#connection-type)
  - [Endpoint Types](types#endpoint-type)
- Events
  - [Overview](events)
  - [Interceptors](interceptors)
- Appearance
  - [Styling via Paint Styles](paint-styles)
  - [Styling via CSS](styling-via-css)
- Querying jsPlumb
  - [Selecting a list of Connections](querying#select)
  - [Selecting a list of Endpoints](querying#selectEndpoints)
- Miscellaneous
  - [Animation](animation)
  - [Utility Functions](utilities)
- Bundling jsPlumb
  - [Webpack](webpack)
- Examples
  - [jsPlumb.connect](connect-examples)
  - [Draggable Connections](draggable-connections-examples)
  - [Miscellaneous](miscellaneous-examples)
- Development
  - [Changelog](changelog)
  - [Which files are which?](development)
  - [Building jsPlumb](Build)
  - [Documentation while developing](development-documentation)
